require 'magma/utils'
require 'pry'

module Magma
  class Reifier
    include Magma::Common
    include Magma::Utils

    def initialize(data_file, options = {})
      @data_file = data_file
      @options = options
    end

    def call
      data # Call once before any chdirs
      puts render_presentations!
    end

    private

    def data
      @data ||= YAML.safe_load(File.read(@data_file), [], [], true)
    end

    def render_presentations!
      bin = which('soffice') || raise('Is LibreOffice installed?')
      Dir.chdir(File.dirname(@data_file)) do
        (data.dig('assets', 'presentations') || []).each do |slide|
          # TODO: check for LFI vulnerability
          raise "Cannot find: #{slide}" unless File.exist?(slide)

          system [
            bin,
            '--headless',
            slide,
            '"macro:///Magma.Writer.WritePNGSlides()"',
          ].join(' ')
        end
      end
    end

    def template!
      # TODO: open up ODP XML and render Liquid templates
    end
  end
end
